﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using Infragistics.Web.UI;

public partial class DynamicWDG : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        WebDataGrid1.DataSource = MakeTable();

        TemplateDataField field1 = new TemplateDataField();
        field1.Key = "TemplateColumn1";
        field1.Header.Text = "Boolean Column";
        this.WebDataGrid1.Columns.Add(field1);

        TemplateDataField templateColumn1 = (TemplateDataField)this.WebDataGrid1.Columns["TemplateColumn1"];      
        templateColumn1.ItemTemplate = new CustomItemTemplate();        
    }

    private void AddColumn(string fieldName, string headerText)
    {
        BoundDataField field = new BoundDataField(true);
        field.Key = "Key_" + fieldName;
        field.DataFieldName = fieldName;
        field.Header.Text = headerText;
        this.WebDataGrid1.Columns.Add(field);
    }

    private DataTable MakeTable()
    {
        // Create a new DataTable.
        System.Data.DataTable table = new DataTable("Table");
        // Declare variables for DataColumn and DataRow objects.
        DataColumn column;
        DataRow row;

        // Create new DataColumn, set DataType, 
        // ColumnName and add to DataTable.    
        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Int32");
        column.ColumnName = "ID";
        column.ReadOnly = true;
        // Add the Column to the DataColumnCollection.
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Item";
        column.AutoIncrement = false;
        column.Caption = "Item";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.DateTime");
        column.ColumnName = "DateColumn";
        column.AutoIncrement = false;
        column.Caption = "DateColumn";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        column = new DataColumn();
        column.DataType = System.Type.GetType("System.String");
        column.ColumnName = "Data";
        column.AutoIncrement = false;
        column.Caption = "Data";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);

        column = new DataColumn();
        column.DataType = System.Type.GetType("System.Boolean");
        column.ColumnName = "BoolColumn";
        column.AutoIncrement = false;
        column.Caption = "BoolColumn";
        column.ReadOnly = false;
        column.Unique = false;
        // Add the column to the table.
        table.Columns.Add(column);


        // Make the ID column the primary key column.
        DataColumn[] PrimaryKeyColumns = new DataColumn[1];
        PrimaryKeyColumns[0] = table.Columns["ID"];
        table.PrimaryKey = PrimaryKeyColumns;


        // Create three new DataRow objects and add 
        // them to the DataTable
        for (int i = 0; i <= 40; i++)
        {
            row = table.NewRow();

            row["ID"] = i;
            row["BoolColumn"] = true;
            row["Item"] = "Item " + i;
            row["DateColumn"] = DateTime.Today;
            row["Data"] = "Data " + i;
            table.Rows.Add(row);
        }
        return table;

    }

    private class CustomItemTemplate : ITemplate
    {
        #region ITemplate Members

        public void InstantiateIn(Control container)
        {
            CheckBox chkBox = new CheckBox();
            chkBox.ID = "TemplateCheckBox";
            // Get the cell value from the DataItem
            chkBox.Checked = (bool)((DataRowView)((TemplateContainer)container).DataItem)["BoolColumn"];

            HyperLink link = new HyperLink();
            link.ID = "TemplateHyperLink";
            string dataValue = (string)((DataRowView)((TemplateContainer)container).DataItem)["Data"];
            link.NavigateUrl = string.Format("http://www.google.bg/search?q={0}", dataValue);
            link.Text = (string)((DataRowView)((TemplateContainer)container).DataItem)["Data"];         

            container.Controls.Add(link);
            container.Controls.Add(chkBox);
        }

        #endregion
    }
}


